package com.example.polygonspheretest;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;

import javax.microedition.khronos.opengles.GL10;

public class MyGround {
	private final FloatBuffer mVertexBuffer;
	private final FloatBuffer mNormalBuffer;

	public MyGround(){

		float vertices[] = new float[8*8/2 * 6*3];  // of (8*8/2) squares
		float norms[] = new float[8*8/2 * 6*3];

		int num = 0;  //num of vertices
		for(int x = -4; x < 4; x++){
			for(int z = -4; z < 4; z++){
				if ((x+z) % 2 == 0) {
					int num_bak = num;
					vertices[num++] = x;	vertices[num++] = -1.2f;	vertices[num++] = z;
					vertices[num++] = x;	vertices[num++] = -1.2f;	vertices[num++] = z+1;
					vertices[num++] = x+1;	vertices[num++] = -1.2f;	vertices[num++] = z+1;
					vertices[num++] = x+1;	vertices[num++] = -1.2f;	vertices[num++] = z+1;
					vertices[num++] = x+1;	vertices[num++] = -1.2f;	vertices[num++] = z;
					vertices[num++] = x;	vertices[num++] = -1.2f;	vertices[num++] = z;

					num = num_bak;
					norms[num++] = 0;	norms[num++] = 1;	norms[num++] = 0;
					norms[num++] = 0;	norms[num++] = 1;	norms[num++] = 0;
					norms[num++] = 0;	norms[num++] = 1;	norms[num++] = 0;
					norms[num++] = 0;	norms[num++] = 1;	norms[num++] = 0;
					norms[num++] = 0;	norms[num++] = 1;	norms[num++] = 0;
					norms[num++] = 0;	norms[num++] = 1;	norms[num++] = 0;
				}
			}
		}

		ByteBuffer vbb = ByteBuffer.allocateDirect(num * 4);
		vbb.order(ByteOrder.nativeOrder());
		mVertexBuffer = vbb.asFloatBuffer();
		mVertexBuffer.put(vertices);
		mVertexBuffer.position(0);

		ByteBuffer nbb = ByteBuffer.allocateDirect(num * 4);
		nbb.order(ByteOrder.nativeOrder());
		mNormalBuffer = nbb.asFloatBuffer();
		mNormalBuffer.put(norms);
		mNormalBuffer.position(0);
	}

	public void draw(GL10 gl){
		float black[] = {0.3f, 0.3f, 0.3f, 1.0f};
		float white[] = {0.7f, 0.7f, 0.7f, 1.0f};

		gl.glVertexPointer(3, GL10.GL_FLOAT, 0, mVertexBuffer);
		gl.glNormalPointer(GL10.GL_FLOAT, 0, mNormalBuffer);
		gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);
		gl.glEnableClientState(GL10.GL_NORMAL_ARRAY);

//		gl.glMaterialfv(GL10.GL_FRONT, GL10.GL_DIFFUSE, white, 0);  // doesn't work ??
		gl.glMaterialfv(GL10.GL_FRONT_AND_BACK, GL10.GL_DIFFUSE, white, 0);
		gl.glDrawArrays(GL10.GL_TRIANGLES, 0, 8*8/2 * 6);

		gl.glRotatef(90, 0, 1, 0);
//		gl.glMaterialfv(GL10.GL_FRONT, GL10.GL_DIFFUSE, black, 0);  // doesn't work ??
		gl.glMaterialfv(GL10.GL_FRONT_AND_BACK, GL10.GL_DIFFUSE, black, 0);
		gl.glDrawArrays(GL10.GL_TRIANGLES, 0, 8*8/2 * 6);
	}
}
