package com.example.polygonspheretest;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.opengl.GLSurfaceView.Renderer;

public class MyRenderer implements Renderer {
	float xrot=0, yrot=0;

	MySphere sphere = new MySphere();
	MyGround ground = new MyGround();

	MyQuat currentRot = new MyQuat();
	MyQuat draggedRot = new MyQuat();
	MyQuat springRot = new MyQuat();

	@Override
	public void onDrawFrame(GL10 gl) {
		gl.glClear(GL10.GL_COLOR_BUFFER_BIT | GL10.GL_DEPTH_BUFFER_BIT);

		gl.glMatrixMode(GL10.GL_MODELVIEW);
		gl.glLoadIdentity();
		ground.draw(gl);

		float[] rotMat = currentRot.mul(draggedRot).toMatrixf();
		gl.glLoadMatrixf(rotMat, 0);
		sphere.draw(gl);
	}

	@Override
	public void onSurfaceChanged(GL10 gl, int width, int height) {
		gl.glViewport(0, 0, width, height);

		gl.glMatrixMode(GL10.GL_PROJECTION);
		gl.glLoadIdentity();
		if (height > width) {
			gl.glFrustumf(-1, 1, -(float)height/width, (float)height/width, 2, 10);
		} else {
			gl.glFrustumf(-(float)width/height, (float)width/height, -1, 1, 2, 10);
		}
		gl.glTranslatef(0, 0, -3);  /* moving viewpoint backward */

	}

	@Override
	public void onSurfaceCreated(GL10 gl, EGLConfig config) {
		gl.glEnable(GL10.GL_DEPTH_TEST);
		gl.glDepthFunc(GL10.GL_LEQUAL);

		gl.glEnable(GL10.GL_LIGHTING);
		gl.glEnable(GL10.GL_LIGHT0);
		gl.glEnable(GL10.GL_CULL_FACE);
		
		float lightpos[] = {3.0f, 4.0f, 10.0f, 1.0f};
		gl.glLightfv(GL10.GL_LIGHT0, GL10.GL_POSITION, lightpos, 0);

		sphere.initTexture(gl);
	}

	public void updateValuesByTick()
	{
		currentRot = currentRot.mul(springRot);
		springRot.dampAngle(0.01);
	}

}
